<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_MeetingPointsZone ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_MeetingPointsZone extends AbstractStructArrayBase
{
    /**
     * The MeetingPointZone
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_MeetingPointsZone[]
     */
    public $MeetingPointZone;
    /**
     * Constructor method for ArrayOfJP_MeetingPointsZone
     * @uses ArrayOfJP_MeetingPointsZone::setMeetingPointZone()
     * @param \StructType\JP_MeetingPointsZone[] $meetingPointZone
     */
    public function __construct(array $meetingPointZone = array())
    {
        $this
            ->setMeetingPointZone($meetingPointZone);
    }
    /**
     * Get MeetingPointZone value
     * @return \StructType\JP_MeetingPointsZone[]|null
     */
    public function getMeetingPointZone()
    {
        return $this->MeetingPointZone;
    }
    /**
     * This method is responsible for validating the values passed to the setMeetingPointZone method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMeetingPointZone method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMeetingPointZoneForArrayConstraintsFromSetMeetingPointZone(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_MeetingPointsZoneMeetingPointZoneItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_MeetingPointsZoneMeetingPointZoneItem instanceof \StructType\JP_MeetingPointsZone) {
                $invalidValues[] = is_object($arrayOfJP_MeetingPointsZoneMeetingPointZoneItem) ? get_class($arrayOfJP_MeetingPointsZoneMeetingPointZoneItem) : sprintf('%s(%s)', gettype($arrayOfJP_MeetingPointsZoneMeetingPointZoneItem), var_export($arrayOfJP_MeetingPointsZoneMeetingPointZoneItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The MeetingPointZone property can only contain items of type \StructType\JP_MeetingPointsZone, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set MeetingPointZone value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_MeetingPointsZone[] $meetingPointZone
     * @return \ArrayType\ArrayOfJP_MeetingPointsZone
     */
    public function setMeetingPointZone(array $meetingPointZone = array())
    {
        // validation for constraint: array
        if ('' !== ($meetingPointZoneArrayErrorMessage = self::validateMeetingPointZoneForArrayConstraintsFromSetMeetingPointZone($meetingPointZone))) {
            throw new \InvalidArgumentException($meetingPointZoneArrayErrorMessage, __LINE__);
        }
        $this->MeetingPointZone = $meetingPointZone;
        return $this;
    }
    /**
     * Add item to MeetingPointZone value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_MeetingPointsZone $item
     * @return \ArrayType\ArrayOfJP_MeetingPointsZone
     */
    public function addToMeetingPointZone(\StructType\JP_MeetingPointsZone $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_MeetingPointsZone) {
            throw new \InvalidArgumentException(sprintf('The MeetingPointZone property can only contain items of type \StructType\JP_MeetingPointsZone, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->MeetingPointZone[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_MeetingPointsZone|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_MeetingPointsZone|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_MeetingPointsZone|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_MeetingPointsZone|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_MeetingPointsZone|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string MeetingPointZone
     */
    public function getAttributeName()
    {
        return 'MeetingPointZone';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_MeetingPointsZone
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
